var CourseCodeInfo = new Class({
	Implements : [ Options ],
	options : {
		uosListingUrl : null,
		tooltipHideSpeed : 250
	},
	initialize : function(options) {
		this.setOptions(options);
		this.uosInfo = {};
		this.loadCourses();

		this.displayTipTitle = new Element('div', { 'id' : 'uos-tooltip-title' });
		this.displayTipFields = new Element('div', { 'id' : 'uos-tooltip-fields' });
		this.displayTipDescription = new Element('div', { 'id' : 'uos-tooltip-description' });
		this.displayTip = new Element('div', {
			id : 'uos-tooltip',
			style : 'position: absolute;',
			events : {
				'mouseover' : function() {
					if(this.hideTipTimer) {
						$clear(this.hideTipTimer);
						delete this.hideTipTimer;
					}
				}.bind(this),
				'mouseout' : function() {
					this.hideTipTimer = this.displayTip.fade.delay(this.options.tooltipHideSpeed, this.displayTip, [ 'out' ]);
				}.bind(this)
			}
		}).adopt(
			this.displayTipTitle,
			this.displayTipFields,
			this.displayTipDescription
		);
		$(document.body).adopt(this.displayTip);
		this.displayTip.fade('hide');
	},
	linkCodes : function() {
		$$('a.course-link').each(function(clink) {
			var code = clink.rel.replace(/^course:/, '');
			if(!this.uosInfo[code])
				return;
			clink.addEvent('mouseover', function() {
				if(this.hideTipTimer) {
					$clear(this.hideTipTimer);
					delete this.hideTipTimer;
				}
				this.displayTipTitle.set('text', this.uosInfo[code].title);
				this.displayTipFields.set('text', this.uosInfo[code].fields);
				this.displayTipDescription.set('html', this.uosInfo[code].description);
				this.displayTip.setStyles({
					'top' : clink.getCoordinates().top + clink.getCoordinates().height,
					'left' : clink.getCoordinates().left
				});
				this.displayTip.fade('in');
			}.bind(this));

			clink.addEvent('mouseout', function() {
				this.hideTipTimer = this.displayTip.fade.delay(this.options.tooltipHideSpeed, this.displayTip, [ 'out' ]);
			}.bind(this));
		}.bind(this));
	},
	loadCourses : function() {
		new Request.HTML({
			url : this.options.uosListingUrl,
			evalScripts : false,
			onSuccess : function(dom) {
				$A(dom).each(function(item) {
					if(item.id == 'w1') {
						$(item).getElements('.uosList').each(function(uos) {
							var titleParts = uos.getElement('.uosListTitle').get('text').match(/([A-Z]{4}[0-9]{4})\s*(.*)/);
							this.uosInfo[titleParts[1]] = {
								code : titleParts[1],
								title : titleParts[2],
								fields : uos.getElement('.visibleFields').get('text'),
								description : uos.getElement('.uosListDescription').get('html')
							};
						}.bind(this));
						this.linkCodes();
					}
				}.bind(this));
			}.bind(this)
		}).get();
	}
});

var uosListingUrls = {
	'/health_sci/postgraduate/' : '/health_sci/postgraduate/faculty_electives.shtml',
	'/arts/undergraduate/' : '/arts/undergraduate/units_of_study/descriptions.shtml'
};

/*window.addEvent('domready', function() {
	// Link up all 
	$('w4').innerHTML = $('w4').innerHTML.replace(/([A-Z]{4}[0-9]{4})/g, '<a href="http://sydney.edu.au/courses/?is_uos_advanced_search=1&page=1&contains_uos_code=$1" rel="course:$1" target="_blank" class="course-link">$1</a>');

	// Look for some standard mappings of UoS listing files for specific handbooks
	uosListingUrls.each(function(path, list) {
		if(document.location.pathname.match(new RegExp('/' + path.replace('/', '\/') + '/i')))
			uosList = list;
	});

	if(!uosList) {
		// Try to guess the default uos path based on the current URL
		var m = document.location.pathname.match(/^\/iw-mount\/default\/main\/ePublishing\/handbooksPreProduction\/WORKAREA\/handbooks\/htdocs\/handbooks\/([^\/]*)\/([^\/]*)\/.*?([^\/]*\.shtml)?$/i);
		var path = m ? m[2] : null;
		var handbook = m ? m[1] : null;
		var file = m ? m[3] : null;
		var uosList = null;

		switch(path) {
			case 'postgraduate':
				uosList = '/handbooks/' + handbook + '/postgraduate/units_of_study.shtml';
				break;
			case 'undergraduate':
				uosList = '/handbooks/' + handbook + '/undergraduate/units_of_study.shtml';
				break;
			default:
				return;
		}
	}

	if(uosList)
		new CourseCodeInfo({ uosListingUrl : uosList });
});*/

window.addEvent('domready', function() {
	// Hack for arts UOS
	var addNames, target = document.location.hash + "", path = document.location.pathname;
	addNames = path.match(/handbooks\/arts\/units_of_study\/table_a.shtml/);
	addNames = addNames || path.match(/handbooks\/arts_PG\/coursework\/units_of_study\/tables.shtml/);

	if(addNames && target.length > 1) {
		$$('h3').each(function(h3) {
			new Element('a', { name : h3.get('text').replace(/\b(of|the|in|and)\b/i, '').replace(/[^a-z0-9]+/gi, '_').toLowerCase() }).inject(h3, 'before');
		});

		document.location.href = path + target;
	}
});